Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1020)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 1021)
@@ -4364,4 +2420,2109 @@
 	//Debug << "importance: " << importance << endl;
 	exporter->SetForcedMaterial(m);
+}
+
+
+/**********************************************************************/
+/*                 BspViewCellsManager implementation                 */
+/**********************************************************************/
+
+
+BspViewCellsManager::BspViewCellsManager(BspTree *bspTree):
+ViewCellsManager(), mBspTree(bspTree)
+{
+	Environment::GetSingleton()->GetIntValue("BspTree.Construction.samples", mInitialSamples);
+	mBspTree->SetViewCellsManager(this);
+	mBspTree->mViewCellsTree = mViewCellsTree;
+}
+
+
+bool BspViewCellsManager::ViewCellsConstructed() const
+{
+	return mBspTree->GetRoot() != NULL;
+}
+
+
+ViewCell *BspViewCellsManager::GenerateViewCell(Mesh *mesh) const
+{
+	return new BspViewCell(mesh);
+}
+
+
+int BspViewCellsManager::ConstructSubdivision(const ObjectContainer &objects,
+											  const VssRayContainer &rays)
+{
+	// if view cells were already constructed
+	if (ViewCellsConstructed())
+		return 0;
+
+	int sampleContributions = 0;
+
+	// construct view cells using the collected samples
+	RayContainer constructionRays;
+	VssRayContainer savedRays;
+
+	const int limit = min(mInitialSamples, (int)rays.size());
+
+	VssRayContainer::const_iterator it, it_end = rays.end();
+
+	const float prop = (float)limit / ((float)rays.size() + Limits::Small);
+
+	for (it = rays.begin(); it != it_end; ++ it)
+	{
+		if (Random(1.0f) < prop)
+			constructionRays.push_back(new Ray(*(*it)));
+		else
+			savedRays.push_back(*it);
+	}
+
+    if (mViewCells.empty())
+	{
+		// no view cells loaded
+		mBspTree->Construct(objects, constructionRays, &mViewSpaceBox);
+		// collect final view cells
+		mBspTree->CollectViewCells(mViewCells);
+	}
+	else
+	{
+		mBspTree->Construct(mViewCells);
+	}
+
+	// destroy rays created only for construction
+	CLEAR_CONTAINER(constructionRays);
+
+	Debug << mBspTree->GetStatistics() << endl;
+
+	//EvaluateViewCellsStats();
+	Debug << "\nView cells after construction:\n" << mCurrentViewCellsStats << endl;
+
+	// recast rest of the rays
+	if (SAMPLE_AFTER_SUBDIVISION)
+		ComputeSampleContributions(savedRays, true, false);
+
+	// real meshes are contructed at this stage
+	if (0)
+	{
+		cout << "finalizing view cells ... ";
+		FinalizeViewCells(true);
+		cout << "finished" << endl;	
+	}
+
+	return sampleContributions;
+}
+
+
+void BspViewCellsManager::CollectViewCells()
+{
+	// view cells tree constructed
+	if (!ViewCellsTreeConstructed())
+	{		
+		mBspTree->CollectViewCells(mViewCells);
+	}
+	else 
+	{
+		// we can use the view cells tree hierarchy to get the right set
+		mViewCellsTree->CollectBestViewCellSet(mViewCells, 
+											   mNumActiveViewCells);
+	}
+}
+
+
+float BspViewCellsManager::GetProbability(ViewCell *viewCell)
+{
+	// compute view cell area as subsititute for probability
+	if (1)
+		return GetVolume(viewCell) / GetViewSpaceBox().GetVolume();
+	else
+		return GetArea(viewCell) / GetAccVcArea();
+}
+
+
+
+int BspViewCellsManager::CastLineSegment(const Vector3 &origin,
+										 const Vector3 &termination,
+										 ViewCellContainer &viewcells)
+{
+	return mBspTree->CastLineSegment(origin, termination, viewcells);
+}
+
+
+int BspViewCellsManager::PostProcess(const ObjectContainer &objects,
+									 const VssRayContainer &rays)
+{
+	if (!ViewCellsConstructed())
+	{
+		Debug << "view cells not constructed" << endl;
+		return 0;
+	}
+	
+	// view cells already finished before post processing step (i.e. because they were loaded)
+	if (mViewCellsFinished)
+	{
+		FinalizeViewCells(true);
+		EvaluateViewCellsStats();
+
+		return 0;
+	}
+
+	//-- post processing of bsp view cells
+
+    int vcSize = 0;
+	int pvsSize = 0;
+
+	//-- merge view cells
+	cout << "starting post processing using " << mPostProcessSamples << " samples ... ";
+	long startTime = GetTime();
+	
+	VssRayContainer postProcessRays;
+	GetRaySets(rays, mPostProcessSamples, postProcessRays);
+
+	if (mMergeViewCells)
+	{
+		cout << "constructing visibility based merge tree" << endl;
+		mViewCellsTree->ConstructMergeTree(rays, objects);
+	}
+	else
+	{
+		cout << "constructing spatial merge tree" << endl;
+
+		// create spatial merge hierarchy
+		ViewCell *root = ConstructSpatialMergeTree(mBspTree->GetRoot());
+		mViewCellsTree->SetRoot(root);
+
+		// compute pvs
+		ObjectPvs pvs;
+		UpdatePvsForEvaluation(root, pvs);
+	}
+
+	// export statistics after merge
+	if (1)
+	{
+		char mstats[100];
+		Environment::GetSingleton()->GetStringValue("ViewCells.mergeStats", mstats);
+		mViewCellsTree->ExportStats(mstats);
+	}
+
+	//-- stats and visualizations
+	cout << "finished" << endl;
+	cout << "merged view cells in "
+		 << TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl;
+
+	Debug << "Postprocessing: Merged view cells in "
+		<< TimeDiff(startTime, GetTime()) * 1e-3 << " secs" << endl << endl;
+	
+
+	//-- visualization and statistics
+    // reset view cells and stats
+	ResetViewCells();
+	Debug << "\nView cells after merge:\n" << mCurrentViewCellsStats << endl;
+
+
+	int savedColorCode  = mColorCode;
+	
+	//BspLeaf::NewMail();
+	if (1) // export merged view cells
+	{
+		mColorCode = 0;
+		
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells.wrl");
+		
+
+		cout << "exporting view cells after merge ... ";
+
+		if (exporter)
+		{
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
+			//exporter->SetWireframe();
+			exporter->SetFilled();
+			ExportViewCellsForViz(exporter);
+
+
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	if (1) // export merged view cells using pvs color coding
+	{
+		mColorCode = 1;
+
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells_pvs.wrl");
+	
+		cout << "exporting view cells after merge (pvs size) ... ";	
+
+		if (exporter)
+		{
+			//exporter->SetWireframe();
+			//exporter->SetForcedMaterial(RandomMaterial());
+
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
+			//exporter->SetWireframe();
+			exporter->SetFilled();
+			ExportViewCellsForViz(exporter);
+
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	
+	// only for testing
+	TestSubdivision();
+
+	mColorCode = savedColorCode;
+
+	// compute final meshes and volume / area
+	if (1) FinalizeViewCells(true);
+
+	// write view cells to disc
+	if (mExportViewCells)
+	{
+		char filename[100];
+		Environment::GetSingleton()->GetStringValue("ViewCells.filename", filename);
+		ExportViewCells(filename, mExportPvs, objects);
+	}
+	
+	// export bounding boxes
+	if (0 && mExportBboxesForPvs)
+	{
+		char filename[100];
+		Environment::GetSingleton()->GetStringValue("ViewCells.boxesFilename", filename);
+		ExportBoundingBoxes(filename, objects);
+	}
+
+
+	return 0;
+}
+
+
+BspViewCellsManager::~BspViewCellsManager()
+{
+}
+
+
+int BspViewCellsManager::GetType() const
+{
+	return BSP;
+}
+
+
+void BspViewCellsManager::Visualize(const ObjectContainer &objects,
+									const VssRayContainer &sampleRays)
+{
+	if (!ViewCellsConstructed())
+		return;
+	
+	int savedColorCode = mColorCode;
+	
+	
+	if (1) // export final view cells
+	{
+		mColorCode = 1; // hack color code
+		Exporter *exporter = Exporter::GetExporter("final_view_cells.x3d");
+	
+		cout << "exporting view cells after merge (pvs size) ... ";	
+
+		if (exporter)
+		{
+			//exporter->SetWireframe();
+			
+			if (mExportGeometry)
+				exporter->ExportGeometry(objects);
+
+			//exporter->SetFilled();
+			const bool b = mUseClipPlaneForViz;
+			mUseClipPlaneForViz = false;
+
+			ExportViewCellsForViz(exporter);
+			
+			mUseClipPlaneForViz = b;
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	mColorCode = savedColorCode;
+
+	//-- visualization of the BSP splits
+	bool exportSplits = false;
+	Environment::GetSingleton()->GetBoolValue("BspTree.Visualization.exportSplits", exportSplits);
+
+	if (exportSplits)
+	{
+		cout << "exporting splits ... ";
+	 	ExportSplits(objects);
+		cout << "finished" << endl;
+	}
+
+	// export single view cells
+	ExportBspPvs(objects);
+}
+
+
+void BspViewCellsManager::ExportSplits(const ObjectContainer &objects)
+{
+	Exporter *exporter = Exporter::GetExporter("bsp_splits.x3d");
+
+	if (exporter)
+	{
+		//exporter->SetFilled();
+
+		if (mExportGeometry)
+			exporter->ExportGeometry(objects);
+
+		Material m;
+		m.mDiffuseColor = RgbColor(1, 0, 0);
+		exporter->SetForcedMaterial(m);
+		exporter->SetWireframe();
+
+		exporter->ExportBspSplits(*mBspTree, true);
+
+		//NOTE: take forced material, else big scenes cannot be viewed
+		m.mDiffuseColor = RgbColor(0, 1, 0);
+		exporter->SetForcedMaterial(m);
+		//exporter->ResetForcedMaterial();
+
+		delete exporter;
+	}
+}
+
+
+void BspViewCellsManager::ExportBspPvs(const ObjectContainer &objects)
+{
+	const int leafOut = 10;
+
+	ViewCell::NewMail();
+
+	//-- some rays for output
+	const int raysOut = min((int)mBspRays.size(), mVisualizationSamples);
+
+	cout << "visualization using " << mVisualizationSamples << " samples" << endl;
+	Debug << "\nOutput view cells: " << endl;
+
+	// sort view cells in order to find the largest view cells
+	if (0)
+		stable_sort(mViewCells.begin(), mViewCells.end(), ViewCell::SmallerPvs);
+
+	int limit = min(leafOut, (int)mViewCells.size());
+
+	for (int i = 0; i < limit; ++ i)
+	{
+		cout << "creating output for view cell " << i << " ... ";
+		VssRayContainer vcRays;
+		Intersectable::NewMail();
+		ViewCell *vc;
+
+		if (0)
+			vc = mViewCells[i];
+		else
+			vc = mViewCells[Random((int)mViewCells.size())];
+
+		cout << "creating output for view cell " << i << " ... ";
+
+		if(0)
+		{
+			// check whether we can add the current ray to the output rays
+			for (int k = 0; k < raysOut; ++ k)
+			{
+				BspRay *ray = mBspRays[k];
+				for	(int j = 0; j < (int)ray->intersections.size(); ++ j)
+				{
+					BspLeaf *leaf = ray->intersections[j].mLeaf;
+					if (vc == leaf->GetViewCell())
+						vcRays.push_back(ray->vssRay);
+				}
+			}
+		}
+
+		//bspLeaves[j]->Mail();
+		char s[64]; sprintf(s, "bsp-pvs%04d.x3d", i);
+
+		Exporter *exporter = Exporter::GetExporter(s);
+
+		exporter->SetWireframe();
+
+		Material m;//= RandomMaterial();
+		m.mDiffuseColor = RgbColor(0, 1, 0);
+		exporter->SetForcedMaterial(m);
+
+		ExportViewCellGeometry(exporter, vc);
+		
+		// export rays piercing this view cell
+		exporter->ExportRays(vcRays, RgbColor(0, 1, 0));
+
+		m.mDiffuseColor = RgbColor(1, 0, 0);
+		exporter->SetForcedMaterial(m);
+
+		ObjectPvsMap::const_iterator it,
+			it_end = vc->GetPvs().mEntries.end();
+
+		exporter->SetFilled();
+
+		// output PVS of view cell
+		for (it = vc->GetPvs().mEntries.begin(); it != it_end; ++ it)
+		{
+			Intersectable *intersect = (*it).first;
+
+			if (!intersect->Mailed())
+			{
+				Material m = RandomMaterial();
+				exporter->SetForcedMaterial(m);
+
+				exporter->ExportIntersectable(intersect);
+				intersect->Mail();
+			}
+		}
+
+		DEL_PTR(exporter);
+		cout << "finished" << endl;
+	}
+
+	Debug << endl;
+}
+
+
+void BspViewCellsManager::TestSubdivision()
+{
+	ViewCellContainer leaves;
+	mViewCellsTree->CollectLeaves(mViewCellsTree->GetRoot(), leaves);
+
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+	const float vol = mViewSpaceBox.GetVolume();
+	float subdivVol = 0;
+	float newVol = 0;
+
+	for (it = leaves.begin(); it != it_end; ++ it)
+	{
+		BspNodeGeometry geom;
+		BspLeaf *leaf = dynamic_cast<BspViewCell *>(*it)->mLeaf;
+		mBspTree->ConstructGeometry(leaf, geom);
+
+		const float lVol = geom.GetVolume();
+		
+		newVol += lVol;
+		subdivVol += (*it)->GetVolume();
+
+		float thres = 0.9f;
+		if ((lVol < ((*it)->GetVolume() * thres)) ||
+			(lVol * thres > ((*it)->GetVolume())))
+			Debug << "warning: " << lVol << " " << (*it)->GetVolume() << endl;
+	}
+	
+	Debug << "exact volume: " << vol << endl;
+	Debug << "subdivision volume: " << subdivVol << endl;
+	Debug << "new volume: " << newVol << endl;
+}
+
+
+void BspViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
+												 ViewCell *vc,
+												 const Plane3 *clipPlane) const
+{
+	if (vc->GetMesh())
+	{
+		exporter->ExportMesh(vc->GetMesh());
+	
+		return;
+	}
+
+	
+	if (clipPlane)
+	{
+		ViewCellContainer leaves;
+		mViewCellsTree->CollectLeaves(vc, leaves);
+		ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+		for (it = leaves.begin(); it != it_end; ++ it)
+		{
+			BspNodeGeometry geom;
+
+			BspNodeGeometry front;
+			BspNodeGeometry back;
+
+			BspLeaf *leaf = dynamic_cast<BspViewCell *>(*it)->mLeaf;
+			mBspTree->ConstructGeometry(leaf, geom);
+
+			const float eps = 0.00000001f;
+			const int cf = geom.Side(*clipPlane, eps);
+
+			if (cf == -1)
+			{
+				exporter->ExportPolygons(geom.GetPolys());
+			}
+			else if (cf == 0)
+			{
+				geom.SplitGeometry(front,
+								   back,
+								   *clipPlane,
+								   mViewSpaceBox, 
+								   eps);
+	
+				//Debug << "geo size: " << geom.Size() << endl;
+				//Debug << "size b: " << back.Size() << " f: " << front.Size() << endl;
+				if (back.Valid())
+				{
+					exporter->ExportPolygons(back.GetPolys());
+				}			
+			}
+		}
+	}
+	else
+	{
+		BspNodeGeometry geom;
+		mBspTree->ConstructGeometry(vc, geom);
+			
+		exporter->ExportPolygons(geom.GetPolys());
+	}
+}
+
+
+void BspViewCellsManager::CreateMesh(ViewCell *vc)
+{
+	// delete previous mesh
+	///DEL_PTR(vc->GetMesh());
+	BspNodeGeometry geom;
+	mBspTree->ConstructGeometry(vc, geom);
+
+	Mesh *mesh = MeshManager::GetSingleton()->CreateResource();
+
+	IncludeNodeGeomInMesh(geom, *mesh);
+	vc->SetMesh(mesh);
+}
+
+
+void BspViewCellsManager::Finalize(ViewCell *viewCell, 
+								   const bool createMesh)
+{
+	float area = 0;
+	float volume = 0;
+
+	ViewCellContainer leaves;
+	mViewCellsTree->CollectLeaves(viewCell, leaves);
+
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+    for (it = leaves.begin(); it != it_end; ++ it)
+	{
+		BspNodeGeometry geom;
+		BspLeaf *leaf = dynamic_cast<BspViewCell *>(*it)->mLeaf;
+		mBspTree->ConstructGeometry(leaf, geom);
+
+		const float lVol = geom.GetVolume();
+		const float lArea = geom.GetArea();
+
+		//(*it)->SetVolume(vol);
+		//(*it)->SetArea(area);
+
+		area += lArea;
+		volume += lVol;
+
+        CreateMesh(*it);
+	}
+
+	viewCell->SetVolume(volume);
+	viewCell->SetArea(area);
+}
+
+
+ViewCell *BspViewCellsManager::GetViewCell(const Vector3 &point, const bool active) const
+{
+	if (!ViewCellsConstructed())
+		return NULL;
+
+	if (!mViewSpaceBox.IsInside(point))
+		return NULL;
+	
+	return mBspTree->GetViewCell(point);
+}
+
+
+void BspViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
+												 vector<MergeCandidate> &candidates)
+{
+	cout << "collecting merge candidates ... " << endl;
+
+	if (mUseRaysForMerge)
+	{
+		mBspTree->CollectMergeCandidates(rays, candidates);
+	}
+	else
+	{
+		vector<BspLeaf *> leaves;
+		mBspTree->CollectLeaves(leaves);
+		mBspTree->CollectMergeCandidates(leaves, candidates);
+	}
+
+	cout << "fininshed collecting candidates" << endl;
+}
+
+
+
+bool BspViewCellsManager::ExportViewCells(const string filename, const bool exportPvs, const ObjectContainer &objects)
+{
+#if STILL_HAS_TODO
+	cout << "exporting view cells to xml ... ";
+	std::ofstream stream;
+
+	// for output we need unique ids for each view cell
+	CreateUniqueViewCellIds();
+
+
+	stream.open(filename.c_str());
+	stream << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"<<endl;
+	stream << "<VisibilitySolution>" << endl;
+
+	//-- the view space bounding box
+	stream << "<ViewSpaceBox" 
+		   << " min=\"" << mViewSpaceBox.Min().x << " " << mViewSpaceBox.Min().y << " " << mViewSpaceBox.Min().z << "\""
+		   << " max=\"" << mViewSpaceBox.Max().x << " " << mViewSpaceBox.Max().y << " " << mViewSpaceBox.Max().z << "\" />" << endl;
+
+	//-- the type of the view cells hierarchy
+	
+	// NOTE: load in vsp bsp here because bsp and vsp bsp can use same tree and vsp bsp is bug free
+	stream << "<Hierarchy name=\"vspBspTree\" >" << endl; 
+	
+	//-- load the view cells itself, i.e., the ids and the pvs
+	stream << "<ViewCells>" << endl;
+
+	mViewCellsTree->Export(stream, exportPvs);
+
+	stream << "</ViewCells>" << endl;
+
+	//-- load the hierarchy
+	stream << "<Hierarchy>" << endl;
+	mBspTree->Export(stream);
+	stream << endl << "</Hierarchy>" << endl;
+
+	stream << "</VisibilitySolution>" << endl;
+	stream.close();
+
+	cout << "finished" << endl;
+#endif
+	return true;
+}
+
+
+ViewCell *BspViewCellsManager::ConstructSpatialMergeTree(BspNode *root)
+{
+	// terminate recursion
+	if (root->IsLeaf())
+	{
+		BspLeaf *leaf = dynamic_cast<BspLeaf *>(root);
+		leaf->GetViewCell()->SetMergeCost(0.0f);
+		return leaf->GetViewCell();
+	}
+	
+	BspInterior *interior = dynamic_cast<BspInterior *>(root);
+	ViewCellInterior *viewCellInterior = new ViewCellInterior();
+		
+	// evaluate merge cost for priority traversal
+	float mergeCost = 1.0f / (float)root->mTimeStamp;
+	viewCellInterior->SetMergeCost(mergeCost);
+
+	float volume = 0;
+	
+	BspNode *front = interior->GetFront();
+	BspNode *back = interior->GetBack();
+
+
+	//-- recursivly compute child hierarchies
+	ViewCell *backVc = ConstructSpatialMergeTree(back);
+	ViewCell *frontVc = ConstructSpatialMergeTree(front);
+
+
+	viewCellInterior->SetupChildLink(backVc);
+	viewCellInterior->SetupChildLink(frontVc);
+
+	volume += backVc->GetVolume();
+	volume += frontVc->GetVolume();	
+
+	viewCellInterior->SetVolume(volume);
+
+	return viewCellInterior;
+}
+
+
+void BspViewCellsManager::UpdatePvsForEvaluation(ViewCell *root, ObjectPvs &pvs)
+{
+	// terminate traversal
+	if (root->IsLeaf())
+	{
+		pvs = root->GetPvs();
+		SetScalarPvsSize(root, pvs.GetSize());
+		
+		return;
+	}
+
+	ViewCellInterior *interior = dynamic_cast<ViewCellInterior *>(root);
+	ViewCellContainer::const_iterator vit, vit_end = interior->mChildren.end();
+
+	vector<ObjectPvs> pvsList;
+	
+	
+	for (vit = interior->mChildren.begin(); vit != vit_end; ++ vit)
+	{
+		ObjectPvs objPvs;
+		
+		//-- recursivly compute child pvss
+		UpdatePvsForEvaluation(*vit, objPvs);
+
+		// store pvs in vector
+		pvsList.push_back(objPvs);
+	}
+
+#if 1
+	Intersectable::NewMail();
+
+	//-- faster way of computing pvs:
+	//   construct merged pvs by adding 
+	//   and only those of the next pvs which were not mailed.
+	//   note: sumpdf is not correct!!
+	vector<ObjectPvs>::iterator oit = pvsList.begin();
+
+	for (vit = interior->mChildren.begin(); vit != vit_end; ++ vit, ++ oit)
+	{
+		
+        ObjectPvsMap::iterator pit, pit_end = (*oit).mEntries.end();
+	
+		for (pit = (*oit).mEntries.begin(); pit != pit_end; ++ pit)
+		{
+			
+			Intersectable *intersect = (*pit).first;
+
+			if (!intersect->Mailed())
+			{
+				pvs.AddSample(intersect, (*pit).second.mSumPdf);
+				intersect->Mail();
+			}
+		}
+	}
+
+	// store pvs in this node
+	if (mViewCellsTree->ViewCellsStorage() == ViewCellsTree::PVS_IN_INTERIORS)
+	{
+		interior->SetPvs(pvs);
+	}
+	
+	// set new pvs size
+    SetScalarPvsSize(interior, pvs.GetSize());
+
+#else
+	// really merge cells: slow nut sumpdf is correct
+	ViewCellInterior *viewCellInterior = new ViewCellInterior();
+
+	viewCellInterior->GetPvs().Merge(backVc->GetPvs());
+	viewCellInterior->GetPvs().Merge(frontVc->GetPvs());
+#endif
+
+}
+
+/************************************************************************/
+/*                   KdViewCellsManager implementation                  */
+/************************************************************************/
+
+
+
+KdViewCellsManager::KdViewCellsManager(KdTree *kdTree):
+ViewCellsManager(), mKdTree(kdTree), mKdPvsDepth(100)
+{
+}
+
+
+float KdViewCellsManager::GetProbability(ViewCell *viewCell)
+{
+	// compute view cell area / volume as subsititute for probability
+	if (0)
+		return GetArea(viewCell) / GetViewSpaceBox().SurfaceArea();
+	else
+		return GetVolume(viewCell) / GetViewSpaceBox().GetVolume();
+}
+
+
+
+
+void KdViewCellsManager::CollectViewCells()
+{
+	//mKdTree->CollectViewCells(mViewCells); TODO
+}
+
+
+int KdViewCellsManager::ConstructSubdivision(const ObjectContainer &objects,
+								  const VssRayContainer &rays)
+{
+	// if view cells already constructed
+	if (ViewCellsConstructed())
+		return 0;
+
+	mKdTree->Construct();
+
+	mTotalAreaValid = false;
+	// create the view cells
+	mKdTree->CreateAndCollectViewCells(mViewCells);
+
+	// cast rays
+	ComputeSampleContributions(rays, true, false);
+
+	EvaluateViewCellsStats();
+	Debug << "\nView cells after construction:\n" << mCurrentViewCellsStats << endl;
+
+	return 0;
+}
+
+
+bool KdViewCellsManager::ViewCellsConstructed() const
+{
+	return mKdTree->GetRoot() != NULL;
+}
+
+
+int KdViewCellsManager::PostProcess(const ObjectContainer &objects,
+									const VssRayContainer &rays)
+{
+	return 0;
+}
+
+
+void KdViewCellsManager::Visualize(const ObjectContainer &objects,
+								   const VssRayContainer &sampleRays)
+{
+	if (!ViewCellsConstructed())
+		return;
+
+	// using view cells instead of the kd PVS of objects
+	const bool useViewCells = true;
+	bool exportRays = false;
+
+	int limit = min(mVisualizationSamples, (int)sampleRays.size());
+	const int pvsOut = min((int)objects.size(), 10);
+	VssRayContainer *rays = new VssRayContainer[pvsOut];
+
+	if (useViewCells)
+	{
+		const int leafOut = 10;
+
+		ViewCell::NewMail();
+
+		//-- some rays for output
+		const int raysOut = min((int)sampleRays.size(), mVisualizationSamples);
+		Debug << "visualization using " << raysOut << " samples" << endl;
+
+		//-- some random view cells and rays for output
+		vector<KdLeaf *> kdLeaves;
+
+		for (int i = 0; i < leafOut; ++ i)
+			kdLeaves.push_back(dynamic_cast<KdLeaf *>(mKdTree->GetRandomLeaf()));
+
+		for (int i = 0; i < kdLeaves.size(); ++ i)
+		{
+			KdLeaf *leaf = kdLeaves[i];
+			RayContainer vcRays;
+
+			cout << "creating output for view cell " << i << " ... ";
+#if 0
+			// check whether we can add the current ray to the output rays
+			for (int k = 0; k < raysOut; ++ k)
+			{
+				Ray *ray = sampleRays[k];
+
+				for (int j = 0; j < (int)ray->bspIntersections.size(); ++ j)
+				{
+					BspLeaf *leaf2 = ray->bspIntersections[j].mLeaf;
+
+					if (leaf->GetViewCell() == leaf2->GetViewCell())
+					{
+						vcRays.push_back(ray);
+					}
+				}
+			}
+#endif
+			Intersectable::NewMail();
+
+			ViewCell *vc = leaf->mViewCell;
+
+			//bspLeaves[j]->Mail();
+			char s[64]; sprintf(s, "kd-pvs%04d.x3d", i);
+
+			Exporter *exporter = Exporter::GetExporter(s);
+			exporter->SetFilled();
+
+			exporter->SetWireframe();
+			//exporter->SetFilled();
+
+			Material m;//= RandomMaterial();
+			m.mDiffuseColor = RgbColor(1, 1, 0);
+			exporter->SetForcedMaterial(m);
+
+			AxisAlignedBox3 box = mKdTree->GetBox(leaf);
+			exporter->ExportBox(box);
+
+			// export rays piercing this view cell
+			exporter->ExportRays(vcRays, 1000, RgbColor(0, 1, 0));
+
+			m.mDiffuseColor = RgbColor(1, 0, 0);
+			exporter->SetForcedMaterial(m);
+
+			// exporter->SetWireframe();
+			exporter->SetFilled();
+
+			ObjectPvsMap::iterator it, it_end = vc->GetPvs().mEntries.end();
+			// -- output PVS of view cell
+			for (it = vc->GetPvs().mEntries.begin(); it !=  it_end; ++ it)
+			{
+				Intersectable *intersect = (*it).first;
+				if (!intersect->Mailed())
+				{
+					exporter->ExportIntersectable(intersect);
+					intersect->Mail();
+				}
+			}
+
+			DEL_PTR(exporter);
+			cout << "finished" << endl;
+		}
+
+		DEL_PTR(rays);
+	}
+	else // using kd PVS of objects
+	{
+		for (int i = 0; i < limit; ++ i)
+		{
+			VssRay *ray = sampleRays[i];
+
+			// check whether we can add this to the rays
+			for (int j = 0; j < pvsOut; j++)
+			{
+				if (objects[j] == ray->mTerminationObject)
+				{
+					rays[j].push_back(ray);
+				}
+			}
+		}
+
+		if (exportRays)
+		{
+			Exporter *exporter = NULL;
+			exporter = Exporter::GetExporter("sample-rays.x3d");
+			exporter->SetWireframe();
+			exporter->ExportKdTree(*mKdTree);
+
+			for (i = 0; i < pvsOut; i++)
+				exporter->ExportRays(rays[i], RgbColor(1, 0, 0));
+
+			exporter->SetFilled();
+
+			delete exporter;
+		}
+
+		for (int k=0; k < pvsOut; k++)
+		{
+			Intersectable *object = objects[k];
+			char s[64];
+			sprintf(s, "sample-pvs%04d.x3d", k);
+
+			Exporter *exporter = Exporter::GetExporter(s);
+			exporter->SetWireframe();
+
+			KdPvsMap::iterator i = object->mKdPvs.mEntries.begin();
+			Intersectable::NewMail();
+
+			// avoid adding the object to the list
+			object->Mail();
+			ObjectContainer visibleObjects;
+
+			for (; i != object->mKdPvs.mEntries.end(); i++)
+			{
+				KdNode *node = (*i).first;
+				exporter->ExportBox(mKdTree->GetBox(node));
+
+				mKdTree->CollectObjects(node, visibleObjects);
+			}
+
+			exporter->ExportRays(rays[k],  RgbColor(0, 1, 0));
+			exporter->SetFilled();
+
+			for (int j = 0; j < visibleObjects.size(); j++)
+				exporter->ExportIntersectable(visibleObjects[j]);
+
+			Material m;
+			m.mDiffuseColor = RgbColor(1, 0, 0);
+			exporter->SetForcedMaterial(m);
+			exporter->ExportIntersectable(object);
+
+			delete exporter;
+		}
+	}
+}
+
+
+ViewCell *KdViewCellsManager::GenerateViewCell(Mesh *mesh) const
+{
+	return new KdViewCell(mesh);
+}
+
+
+void KdViewCellsManager::ExportViewCellGeometry(Exporter *exporter,
+												ViewCell *vc,
+												const Plane3 *clipPlane) const
+{
+	ViewCellContainer leaves;
+
+	mViewCellsTree->CollectLeaves(vc, leaves);
+	ViewCellContainer::const_iterator it, it_end = leaves.end();
+
+	for (it = leaves.begin(); it != it_end; ++ it)
+	{
+		KdViewCell *kdVc = dynamic_cast<KdViewCell *>(*it);
+	
+		exporter->ExportBox(mKdTree->GetBox(kdVc->mLeaf));
+	}
+}
+
+
+int KdViewCellsManager::GetType() const
+{
+	return ViewCellsManager::KD;
+}
+
+
+
+KdNode *KdViewCellsManager::GetNodeForPvs(KdLeaf *leaf)
+{
+	KdNode *node = leaf;
+
+	while (node->mParent && node->mDepth > mKdPvsDepth)
+		node = node->mParent;
+	return node;
+}
+
+int KdViewCellsManager::CastLineSegment(const Vector3 &origin,
+										const Vector3 &termination,
+										ViewCellContainer &viewcells)
+{
+	return mKdTree->CastLineSegment(origin, termination, viewcells);
+}
+
+
+void KdViewCellsManager::CreateMesh(ViewCell *vc)
+{
+	// TODO
+}
+
+
+
+void KdViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
+												vector<MergeCandidate> &candidates)
+{
+	// TODO
+}
+
+
+
+
+/**************************************************************************/
+/*                   VspBspViewCellsManager implementation                */
+/**************************************************************************/
+
+
+VspBspViewCellsManager::VspBspViewCellsManager(VspBspTree *vspBspTree):
+ViewCellsManager(), mVspBspTree(vspBspTree)
+{
+	Environment::GetSingleton()->GetIntValue("VspBspTree.Construction.samples", mInitialSamples);
+	mVspBspTree->SetViewCellsManager(this);
+	mVspBspTree->mViewCellsTree = mViewCellsTree;
+}
+
+
+VspBspViewCellsManager::~VspBspViewCellsManager()
+{
+}
+
+
+float VspBspViewCellsManager::GetProbability(ViewCell *viewCell)
+{
+	if (0 && mVspBspTree->mUseAreaForPvs)
+		return GetArea(viewCell) / GetAccVcArea();
+	else
+		return GetVolume(viewCell) / mViewSpaceBox.GetVolume();
+}
+
+
+void VspBspViewCellsManager::CollectViewCells()
+{
+	// view cells tree constructed
+	if (!ViewCellsTreeConstructed())
+	{
+		mVspBspTree->CollectViewCells(mViewCells, false);
+	}
+	else 
+	{	// we can use the view cells tree hierarchy to get the right set
+		mViewCellsTree->CollectBestViewCellSet(mViewCells, mNumActiveViewCells);
+	}
+}
+
+
+void VspBspViewCellsManager::CollectMergeCandidates(const VssRayContainer &rays, 
+													vector<MergeCandidate> &candidates)
+{	
+	cout << "collecting merge candidates ... " << endl;
+
+	if (mUseRaysForMerge)
+	{
+		mVspBspTree->CollectMergeCandidates(rays, candidates);
+	}
+	else
+	{
+		vector<BspLeaf *> leaves;
+		mVspBspTree->CollectLeaves(leaves);
+	
+		mVspBspTree->CollectMergeCandidates(leaves, candidates);
+	}
+
+	cout << "fininshed collecting candidates" << endl;
+}
+
+
+bool VspBspViewCellsManager::ViewCellsConstructed() const
+{
+	return mVspBspTree->GetRoot() != NULL;
+}
+
+
+ViewCell *VspBspViewCellsManager::GenerateViewCell(Mesh *mesh) const
+{
+	return new BspViewCell(mesh);
+}
+
+
+int VspBspViewCellsManager::ConstructSubdivision(const ObjectContainer &objects,
+												 const VssRayContainer &rays)
+{
+	mMaxPvsSize = (int)(mMaxPvsRatio * (float)objects.size());
+
+	// if view cells were already constructed
+	if (ViewCellsConstructed())
+		return 0;
+
+	int sampleContributions = 0;
+
+	VssRayContainer sampleRays;
+
+	int limit = min (mInitialSamples, (int)rays.size());
+
+	VssRayContainer constructionRays;
+	VssRayContainer savedRays;
+
+	Debug << "samples used for vsp bsp subdivision: " << mInitialSamples 
+		  << ", actual rays: " << (int)rays.size() << endl;
+
+	GetRaySets(rays, mInitialSamples, constructionRays, &savedRays);
+
+	Debug << "initial rays: " << (int)constructionRays.size() << endl;
+	Debug << "saved rays: " << (int)savedRays.size() << endl;
+
+	long startTime;
+
+	if (1)
+		mVspBspTree->Construct(constructionRays, &mViewSpaceBox);
+	else
+		mVspBspTree->Construct(rays, &mViewSpaceBox);
+
+	// collapse invalid regions
+	cout << "collapsing invalid tree regions ... ";
+	startTime = GetTime();
+	const int collapsedLeaves = mVspBspTree->CollapseTree();
+	Debug << "collapsed in " << TimeDiff(startTime, GetTime()) * 1e-3 
+		  << " seconds" << endl;
+
+    cout << "finished" << endl;
+
+	//-- stats
+	Debug << mVspBspTree->GetStatistics() << endl;
+
+	ResetViewCells();
+	Debug << "\nView cells after construction:\n" << mCurrentViewCellsStats << endl;
+
+
+	startTime = GetTime();
+
+	cout << "Computing remaining ray contributions ... ";
+
+	// recast rest of rays
+	if (SAMPLE_AFTER_SUBDIVISION)
+		ComputeSampleContributions(savedRays, true, false);
+
+	cout << "finished" << endl;
+
+	Debug << "Computed remaining ray contribution in " << TimeDiff(startTime, GetTime()) * 1e-3
+		  << " secs" << endl;
+
+	cout << "construction finished" << endl;
+
+	// real meshes are contructed at this stage
+	if (0)
+	{
+		cout << "finalizing view cells ... ";
+		FinalizeViewCells(true);
+		cout << "finished" << endl;
+	}
+
+	return sampleContributions;
+}
+
+
+void VspBspViewCellsManager::MergeViewCells(const VssRayContainer &rays,
+											const ObjectContainer &objects)
+{
+    int vcSize = 0;
+	int pvsSize = 0;
+
+	//-- merge view cells
+	cout << "starting merge using " << mPostProcessSamples << " samples ... " << endl;
+	long startTime = GetTime();
+
+
+	if (mMergeViewCells)
+	{
+		// TODO: should be done BEFORE the ray casting
+		// compute tree by merging the nodes based on cost heuristics
+		mViewCellsTree->ConstructMergeTree(rays, objects);
+	}
+	else
+	{
+		// compute tree by merging the nodes of the spatial hierarchy
+		ViewCell *root = ConstructSpatialMergeTree(mVspBspTree->GetRoot());
+		mViewCellsTree->SetRoot(root);
+
+		// compute pvs
+		ObjectPvs pvs;
+		UpdatePvsForEvaluation(root, pvs);
+	}
+
+	if (1)
+	{
+		char mstats[100];
+		ObjectPvs pvs;
+
+		Environment::GetSingleton()->GetStringValue("ViewCells.mergeStats", mstats);
+		mViewCellsTree->ExportStats(mstats);
+	}
+
+	//-- stats and visualizations
+	cout << "finished merging" << endl;
+	cout << "merged view cells in "
+		 << TimeDiff(startTime, GetTime()) *1e-3 << " secs" << endl;
+
+	Debug << "Postprocessing: Merged view cells in "
+		  << TimeDiff(startTime, GetTime()) *1e-3 << " secs" << endl << endl;
+	
+
+	int savedColorCode = mColorCode;
+	
+	// get currently active view cell set
+	ResetViewCells();
+	Debug << "\nView cells after merge:\n" << mCurrentViewCellsStats << endl;
+
+	//BspLeaf::NewMail();
+	if (1) // export merged view cells
+	{
+		mColorCode = 0;
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells.wrl");
+		
+		cout << "exporting view cells after merge ... ";
+
+		if (exporter)
+		{
+			if (0)
+				exporter->SetWireframe();
+			else
+				exporter->SetFilled();
+
+			ExportViewCellsForViz(exporter);
+
+			if (mExportGeometry)
+			{
+				Material m;
+				m.mDiffuseColor = RgbColor(0, 1, 0);
+				exporter->SetForcedMaterial(m);
+				exporter->SetFilled();
+
+				exporter->ExportGeometry(objects);
+			}
+
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	if (1) // export merged view cells using pvs coding
+	{
+		mColorCode = 1;
+
+		Exporter *exporter = Exporter::GetExporter("merged_view_cells_pvs.wrl");
+	
+		cout << "exporting view cells after merge (pvs size) ... ";	
+
+		if (exporter)
+		{
+			if (0)
+				exporter->SetWireframe();
+			else
+				exporter->SetFilled();
+
+			ExportViewCellsForViz(exporter);
+
+			if (mExportGeometry)
+			{
+				Material m;
+				m.mDiffuseColor = RgbColor(0, 1, 0);
+				exporter->SetForcedMaterial(m);
+				exporter->SetFilled();
+
+				exporter->ExportGeometry(objects);
+			}
+
+			delete exporter;
+		}
+		cout << "finished" << endl;
+	}
+
+	mColorCode = savedColorCode;
+
+}
+
+
+bool VspBspViewCellsManager::EqualToSpatialNode(ViewCell *viewCell) const
+{
+	return GetSpatialNode(viewCell) != NULL;
+}
+
+
+BspNode *VspBspViewCellsManager::GetSpatialNode(ViewCell *viewCell) const
+{
+	if (!viewCell->IsLeaf())
+	{
+		BspViewCell *bspVc = dynamic_cast<BspViewCell *>(viewCell);
+
+		return bspVc->mLeaf;
+ 	}
+	else
+	{
+		ViewCellInterior *interior = dynamic_cast<ViewCellInterior *>(viewCell);
+
+		// cannot be node of binary tree
+		if (interior->mChildren.size() != 2)
+			return NULL;
+
+		ViewCell *left = interior->mChildren[0];
+		ViewCell *right = interior->mChildren[1];
+
+		BspNode *leftNode = GetSpatialNode(left);
+		BspNode *rightNode = GetSpatialNode(right);
+
+		if (leftNode && rightNode && leftNode->IsSibling(rightNode))
+		{
+			return leftNode->GetParent(); 
+		}
+	}
+
+	return NULL;
+}
+
+
+void VspBspViewCellsManager::RefineViewCells(const VssRayContainer &rays,
+											 const ObjectContainer &objects)
+{
+	Debug << "render time before refine:" << endl;
+	mRenderer->RenderScene();
+	SimulationStatistics ss;
+	dynamic_cast<RenderSimulator *>(mRenderer)->GetStatistics(ss);
+    Debug << ss << endl;
+
+	cout << "Refining the merged view cells ... ";
+	long startTime = GetTime();
+
+	// refining the merged view cells
+	const int refined = mViewCellsTree->RefineViewCells(rays, objects);
+
+	//-- stats and visualizations
+	cout << "finished" << endl;
+	cout << "refined " << refined << " view cells in "
+		 << TimeDiff(startTime, GetTime()) *1e-3 << " secs" << endl;
+
+	Debug << "Postprocessing: refined " << refined << " view cells in "
+		  << TimeDiff(startTime, GetTime()) *1e-3 << " secs" << endl << endl;
+}
+
+
+int VspBspViewCellsManager::PostProcess(const ObjectContainer &objects,
+										const VssRayContainer &rays)
+{
+	if (!ViewCellsConstructed())
+	{
+		Debug << "postprocess error: no view cells constructed" << endl;
+		return 0;
+	}
+
+
+	// view cells already finished before post processing step 
+	// (i.e. because they were loaded)
+	if (mViewCellsFinished)
+	{
+		FinalizeViewCells(true);
+		EvaluateViewCellsStats();
+
+		return 0;
+	}
+
+	// check if new view cells turned invalid
+	int minPvs, maxPvs;
+
+	if (0)
+	{
+		minPvs = mMinPvsSize;
+		maxPvs = mMaxPvsSize;
+	}
+	else
+	{
+		minPvs = mPruneEmptyViewCells ? 1 : 0;
+		maxPvs = mMaxPvsSize;
+	}
+
+	Debug << "setting validity, min: " << minPvs << " max: " << maxPvs << endl;
+	cout << "setting validity, min: " << minPvs << " max: " << maxPvs << endl;
+	
+	SetValidity(minPvs, maxPvs); 
+
+	// update valid view space according to valid view cells
+	if (0) mVspBspTree->ValidateTree();
+
+	// area has to be recomputed
+	mTotalAreaValid = false;
+	VssRayContainer postProcessRays;
+	GetRaySets(rays, mPostProcessSamples, postProcessRays);
+
+	Debug << "post processing using " << (int)postProcessRays.size() << " samples" << endl;
+
+
+	// should maybe be done here to allow merge working with area or volume
+	// and to correct the rendering statistics
+	if (0) FinalizeViewCells(false);
+		
+	//-- merge the individual view cells
+	MergeViewCells(postProcessRays, objects);
+	
+
+	// only for debugging purpose: test if the subdivision is valid
+	TestSubdivision();
+
+	//-- refines the merged view cells
+	if (0) RefineViewCells(postProcessRays, objects);
+
+	
+	//-- render simulation after merge + refine
+	cout << "\nevaluating bsp view cells render time before compress ... ";
+	dynamic_cast<RenderSimulator *>(mRenderer)->RenderScene();
+	SimulationStatistics ss;
+	dynamic_cast<RenderSimulator *>(mRenderer)->GetStatistics(ss);
+  
+
+	cout << " finished" << endl;
+	cout << ss << endl;
+	Debug << ss << endl;
+
+
+	//-- compression
+	if (ViewCellsTreeConstructed() && mCompressViewCells)
+	{
+		int pvsEntries = mViewCellsTree->GetNumPvsEntries(mViewCellsTree->GetRoot());
+		Debug << "number of entries before compress: " << pvsEntries << endl;
+
+		mViewCellsTree->SetViewCellsStorage(ViewCellsTree::COMPRESSED);
+
+		pvsEntries = mViewCellsTree->GetNumPvsEntries(mViewCellsTree->GetRoot());
+		Debug << "number of entries after compress: " << pvsEntries << endl;
+	}
+
+
+	// collapse sibling leaves that share the same view cell
+	if (0) mVspBspTree->CollapseTree();
+
+	// recompute view cell list and statistics
+	ResetViewCells();
+
+	// compute final meshes and volume / area
+	if (1) FinalizeViewCells(true);
+
+	// write view cells to disc
+	if (mExportViewCells)
+	{
+		char filename[100];
+		Environment::GetSingleton()->GetStringValue("ViewCells.filename", filename);
+		ExportViewCells(filename, mExportPvs, objects);
+	}
+
+	
+	// export bounding boxes
+	if (mExportBboxesForPvs)
+	{
+		char filename[100];
+		Environment::GetSingleton()->GetStringValue("ViewCells.boxesFilename", filename);
+	
+		ExportBoundingBoxes(filename, objects);
+	}
+
+	return 0;
+}
+
+
+int VspBspViewCellsManager::GetType() const
+{
+	return VSP_BSP;
+}
+
+
+ViewCell *VspBspViewCellsManager::ConstructSpatialMergeTree(BspNode *root)
+{
+	// terminate recursion
+	if (root->IsLeaf())
+	{
+		BspLeaf *leaf = dynamic_cast<BspLeaf *>(root);
+		leaf->GetViewCell()->SetMergeCost(0.0f);
+		return leaf->GetViewCell();
+	}
+	
+	
+	BspInterior *interior = dynamic_cast<BspInterior *>(root);
+	ViewCellInterior *viewCellInterior = new ViewCellInterior();
+		
+	// evaluate merge cost for priority traversal
+	float mergeCost = 1.0f / (float)root->mTimeStamp;
+	viewCellInterior->SetMergeCost(mergeCost);
+
+	float volume = 0;
+	
+	BspNode *front = interior->GetFront();
+	BspNode *back = interior->GetBack();
+
+
+	ObjectPvs frontPvs, backPvs;
+
+	//-- recursivly compute child hierarchies
+	ViewCell *backVc = ConstructSpatialMergeTree(back);
+	ViewCell *frontVc = ConstructSpatialMergeTree(front);
+
+
+	viewCellInterior->SetupChildLink(backVc);
+	viewCellInterior->SetupChildLink(frontVc);
+
+	volume += backVc->GetVolume();
+	volume += frontVc->GetVolume();	
+
+	viewCellInterior->SetVolume(volume);
+
+	return viewCellInterior;
+}
+
+
+
+void VspBspViewCellsManager::UpdatePvsForEvaluation(ViewCell *root, ObjectPvs &pvs)
+{
+	// terminate traversal
+	if (root->IsLeaf())
+	{
+		pvs = root->GetPvs();
+		SetScalarPvsSize(root, root->GetPvs().GetSize());
+		
+		return;
+	}
+	
+	//-- interior node => propagate pvs up
+	ViewCellInterior *interior = dynamic_cast<ViewCellInterior *>(root);
+	interior->GetPvs().Clear();
+	pvs.Clear();
+	vector<ObjectPvs> pvsList;
+
+	ViewCellContainer::const_iterator vit, vit_end = interior->mChildren.end();
+
+	for (vit = interior->mChildren.begin(); vit != vit_end; ++ vit)
+	{
+		ObjectPvs objPvs;
+		
+		//-- recursivly compute child pvss
+		UpdatePvsForEvaluation(*vit, objPvs);
+
+		// store pvs in vector
+		pvsList.push_back(objPvs);
+	}
+
+#if 1
+
+	Intersectable::NewMail();
+
+	//-- faster way of computing pvs:
+	//   construct merged pvs by adding 
+	//   and only those of the next pvs which were not mailed.
+	//   note: sumpdf is not correct!!
+	vector<ObjectPvs>::iterator oit = pvsList.begin();
+
+	for (vit = interior->mChildren.begin(); vit != vit_end; ++ vit, ++ oit)
+	{
+	    ObjectPvsMap::iterator pit, pit_end = (*oit).mEntries.end();
+	
+		for (pit = (*oit).mEntries.begin(); pit != pit_end; ++ pit)
+		{
+			Intersectable *intersect = (*pit).first;
+
+			if (!intersect->Mailed())
+			{
+				pvs.AddSample(intersect, (*pit).second.mSumPdf);
+				intersect->Mail();
+			}
+		}
+	}
+
+	// store pvs in this node
+	if (mViewCellsTree->ViewCellsStorage() == ViewCellsTree::PVS_IN_INTERIORS)
+	{
+		interior->SetPvs(pvs);
+	}
+	
+	// set new pvs size
+	SetScalarPvsSize(interior, pvs.GetSize());
+	
+
+#else
+
+	// really merge cells: slow but sumpdf is correct
+	viewCellInterior->GetPvs().Merge(backVc->GetPvs());
+	viewCellInterior->GetPvs().Merge(frontVc->GetPvs());
+#endif
+
+}
+
+
+bool VspBspViewCellsManager::GetViewPoint(Vector3 &viewPoint) const
+{
+	if (!ViewCellsConstructed())
+		return ViewCellsManager::GetViewPoint(viewPoint);
+
+	// TODO: set reasonable limit
+	const int limit = 20;
+
+	for (int i = 0; i < limit; ++ i)
+	{
+		viewPoint = mViewSpaceBox.GetRandomPoint();
+		if (mVspBspTree->ViewPointValid(viewPoint))
+		{
+			return true;
+		}
+	}
+
+	Debug << "failed to find valid view point, taking " << viewPoint << endl;
+	return false;
+}
+
+
+bool VspBspViewCellsManager::ViewPointValid(const Vector3 &viewPoint) const
+{
+  // $$JB -> implemented in viewcellsmanager (slower, but allows dynamic
+  // validy update in preprocessor for all managers)
+  return ViewCellsManager::ViewPointValid(viewPoint);
+
+  //	return mViewSpaceBox.IsInside(viewPoint) &&
+  //		   mVspBspTree->ViewPointValid(viewPoint);
+}
+
+
+void VspBspViewCellsManager::Visualize(const ObjectContainer &objects,
+									   const VssRayContainer &sampleRays)
+{
+	if (!ViewCellsConstructed())
+		return;
+
+	VssRayContainer visRays;
+	GetRaySets(sampleRays, mVisualizationSamples, visRays);
+
+	//-- export view cells
+	if (1) 
+	{	// hack pvs
+		const int savedColorCode = mColorCode;
+		mColorCode = 1;
+	
+		Exporter *exporter = Exporter::GetExporter("final_view_cells.wrl");
+		
+		if (exporter)
+		{
+			cout << "exporting view cells after post process ... ";
+
+			if (0)
+			{
+				// export view space box
+				exporter->SetWireframe();
+				exporter->ExportBox(mViewSpaceBox);
+				exporter->SetFilled();
+			}
+
+			if (mExportGeometry)
+			{
+				exporter->ExportGeometry(objects);
+			}
+
+			// export rays
+			if (1 && mExportRays)
+			{
+				exporter->ExportRays(visRays, RgbColor(0, 1, 0));
+			}
+
+			//exporter->SetFilled();
+
+			// HACK: export without clip plane
+			const bool b = mUseClipPlaneForViz;
+			mUseClipPlaneForViz = false;
+
+			ExportViewCellsForViz(exporter);
+			
+			mUseClipPlaneForViz = b;
+			delete exporter;
+
+			cout << "finished" << endl;
+		}
+
+		mColorCode = savedColorCode;
+	}
+
+
+	if (0)
+	{
+		cout << "exporting depth map ... ";
+
+		Exporter *exporter = Exporter::GetExporter("depth_map.x3d");
+		if (exporter)
+		{
+			if (1)
+			{
+				exporter->SetWireframe();
+				exporter->ExportBox(mViewSpaceBox);
+				exporter->SetFilled();
+			}
+
+			if (mExportGeometry)
+			{
+				exporter->ExportGeometry(objects);
+			}
+
+			const int maxDepth = mVspBspTree->mBspStats.maxDepth;
+
+			ViewCellContainer::const_iterator vit, vit_end = mViewCells.end();
+
+			for (vit = mViewCells.begin(); vit != mViewCells.end(); ++ vit)
+			{
+				ViewCell *vc = *vit;
+
+				ViewCellContainer leaves;
+				mViewCellsTree->CollectLeaves(vc, leaves);
+
+				ViewCellContainer::const_iterator lit, lit_end = leaves.end();
+
+				for (lit = leaves.begin(); lit != lit_end; ++ lit)
+				{
+					BspLeaf *leaf = dynamic_cast<BspViewCell *>(*lit)->mLeaf;
+
+					Material m; 
+
+					float relDepth = (float)leaf->GetDepth() / (float)maxDepth;
+					m.mDiffuseColor.r = relDepth;
+					m.mDiffuseColor.g = 0.0f;
+					m.mDiffuseColor.b = 1.0f - relDepth;
+
+                    exporter->SetForcedMaterial(m);
+				
+
+					BspNodeGeometry geom;
+					mVspBspTree->ConstructGeometry(leaf, geom);
+					exporter->ExportPolygons(geom.GetPolys());
+				}
+			}
+
+			delete exporter;
+		}
+
+
+		cout << "finished" << endl;
+	}
+
+	//-- visualization of the BSP splits
+	bool exportSplits = false;
+	Environment::GetSingleton()->GetBoolValue("VspBspTree.Visualization.exportSplits", exportSplits);
+
+	if (exportSplits)
+	{
+		cout << "exporting splits ... ";
+	 	ExportSplits(objects, visRays);
+		cout << "finished" << endl;
+	}
+
+	//-- export single view cells
+	ExportBspPvs(objects, visRays);
+}
+
+
+void VspBspViewCellsManager::ExportSplits(const ObjectContainer &objects,
+										  const VssRayContainer &rays)
+{
+	Exporter *exporter = Exporter::GetExporter("bsp_splits.x3d");
+
+	if (exporter)
+	{
+		Material m;
+		m.mDiffuseColor = RgbColor(1, 0, 0);
+		exporter->SetForcedMaterial(m);
+		exporter->SetWireframe();
+
+		exporter->ExportBspSplits(*mVspBspTree, true);
+
+		// take forced material, else big scenes cannot be viewed
+		m.mDiffuseColor = RgbColor(0, 1, 0);
+		exporter->SetForcedMaterial(m);
+		exporter->SetFilled();
+
+		exporter->ResetForcedMaterial();
+
+		// export rays
+		if (mExportRays)
+			exporter->ExportRays(rays, RgbColor(1, 1, 0));
+
+		if (mExportGeometry)
+			exporter->ExportGeometry(objects);
+
+		delete exporter;
+	}
+}
+
+
+void VspBspViewCellsManager::ExportBspPvs(const ObjectContainer &objects,
+										  const VssRayContainer &rays)
+{
+	int leafOut;
+	Environment::GetSingleton()->GetIntValue("ViewCells.Visualization.maxOutput", leafOut);
+
+	ViewCell::NewMail();
+
+	cout << "visualization using " << (int)rays.size() << " samples" << endl;
+	Debug << "visualization using " << (int)rays.size() << " samples" << endl;
+	Debug << "\nOutput view cells: " << endl;
+
+	const bool sortViewCells = true;
+
+	// sort view cells to visualize the largest view cells
+	if (sortViewCells)
+	{
+		//stable_sort(mViewCells.begin(), mViewCells.end(), ViewCell::SmallerPvs);
+		stable_sort(mViewCells.begin(), mViewCells.end(), ViewCell::LargerRenderCost);
+	}
+
+	int limit = min(leafOut, (int)mViewCells.size());
+
+	int raysOut = 0;
+
+	//-- some rays for output
+	for (int i = 0; i < limit; ++ i)
+	{
+		cout << "creating output for view cell " << i << " ... ";
+
+		ViewCell *vc;
+	
+		if (sortViewCells) // largest view cell pvs first
+			vc = mViewCells[i];
+		else
+			vc = mViewCells[(int)RandomValue(0, (float)mViewCells.size() - 1)];
+
+		ObjectPvs pvs;
+		mViewCellsTree->GetPvs(vc, pvs);
+
+		//bspLeaves[j]->Mail();
+		char s[64]; sprintf(s, "bsp-pvs%04d.wrl", i);
+		Exporter *exporter = Exporter::GetExporter(s);
+		
+		Debug << i << ": pvs size=" << (int)mViewCellsTree->GetPvsSize(vc) << endl;
+
+		//-- export the sample rays
+		if (mExportRays)
+		{
+			// output rays stored with the view cells during subdivision
+			if (0)
+			{
+				VssRayContainer vcRays;
+                VssRayContainer collectRays;
+
+				raysOut = min((int)rays.size(), 100);
+
+				// collect intial view cells
+				ViewCellContainer leaves;
+				mViewCellsTree->CollectLeaves(vc, leaves);
+
+				ViewCellContainer::const_iterator vit, vit_end = leaves.end();
+       
+				for (vit = leaves.begin(); vit != vit_end; ++ vit)
+				{
+					BspLeaf *vcLeaf = dynamic_cast<BspViewCell *>(*vit)->mLeaf;
+				
+					VssRayContainer::const_iterator rit, rit_end = vcLeaf->mVssRays.end();
+
+					for (rit = vcLeaf->mVssRays.begin(); rit != rit_end; ++ rit)
+					{
+						collectRays.push_back(*rit);
+					}
+				}
+
+				VssRayContainer::const_iterator rit, rit_end = collectRays.end();
+
+				for (rit = collectRays.begin(); rit != rit_end; ++ rit)
+				{
+					float p = RandomValue(0.0f, (float)collectRays.size());
+			
+					if (p < raysOut)
+						vcRays.push_back(*rit);
+				}
+
+				//-- export rays piercing this view cell
+				exporter->ExportRays(vcRays, RgbColor(1, 1, 1));
+			}
+		
+			// associate new rays with output view cell
+			if (1)
+			{
+				VssRayContainer vcRays;
+				raysOut = min((int)rays.size(), mVisualizationSamples);
+
+				// check whether we can add the current ray to the output rays
+				for (int k = 0; k < raysOut; ++ k)
+				{
+					VssRay *ray = rays[k];
+					for	(int j = 0; j < (int)ray->mViewCells.size(); ++ j)
+					{
+						ViewCell *rayvc = ray->mViewCells[j];
+	
+						if (rayvc == vc)
+							vcRays.push_back(ray);
+					}
+				}	
+				
+				//-- export rays piercing this view cell
+				exporter->ExportRays(vcRays, RgbColor(1, 1, 0));
+			}
+
+		}
+		
+
+		//-- export view cell geometry
+		exporter->SetWireframe();
+
+		Material m;//= RandomMaterial();
+		m.mDiffuseColor = RgbColor(0, 1, 0);
+		exporter->SetForcedMaterial(m);
+
+		ExportViewCellGeometry(exporter, vc);
+	
+		exporter->SetFilled();
+
+
+		//-- export pvs
+		if (1)
+		{
+			ObjectPvsMap::const_iterator oit,
+				oit_end = pvs.mEntries.end();
+
+			Intersectable::NewMail();
+
+			// output PVS of view cell
+			for (oit = pvs.mEntries.begin(); oit != oit_end; ++ oit)
+			{		
+				Intersectable *intersect = (*oit).first;
+
+				if (!intersect->Mailed())
+				{
+					m = RandomMaterial();
+					exporter->SetForcedMaterial(m);
+
+					exporter->ExportIntersectable(intersect);
+					intersect->Mail();
+				}
+			}
+		}
+		
+		if (0)
+		{   // export scene geometry
+			m.mDiffuseColor = RgbColor(1, 0, 0);
+			exporter->SetForcedMaterial(m);
+
+			exporter->ExportGeometry(objects);
+		}
+
+		DEL_PTR(exporter);
+		cout << "finished" << endl;
+	}
+
+	Debug << endl;
+}
+
+
+void VspBspViewCellsManager::TestFilter(const ObjectContainer &objects)
+{
+	Exporter *exporter = Exporter::GetExporter("filter.x3d");
+
+	Vector3 bsize = mViewSpaceBox.Size();
+	const Vector3 viewPoint(mViewSpaceBox.Center());
+	float w = Magnitude(mViewSpaceBox.Size()) * mFilterWidth;
+	const Vector3 width = Vector3(w);
+	
+	PrVs testPrVs;
+	
+	if (exporter)
+	{
+		ViewCellContainer viewCells;
+	
+        const AxisAlignedBox3 tbox = GetFilterBBox(viewPoint, mFilterWidth);
+
+		GetPrVS(viewPoint, testPrVs, GetFilterWidth());
+
+		exporter->SetWireframe();
+
+		exporter->SetForcedMaterial(RgbColor(1,1,1));
+		exporter->ExportBox(tbox);
+		
+		exporter->SetFilled();
+
+		exporter->SetForcedMaterial(RgbColor(0,1,0));
+		ExportViewCellGeometry(exporter, GetViewCell(viewPoint));
+
+		//exporter->ResetForcedMaterial();
+		exporter->SetForcedMaterial(RgbColor(0,0,1));
+		ExportViewCellGeometry(exporter, testPrVs.mViewCell);
+
+     	exporter->SetForcedMaterial(RgbColor(1,0,0));
+		exporter->ExportGeometry(objects);
+
+		delete exporter;
+	}
+}
+
+
+int VspBspViewCellsManager::ComputeBoxIntersections(const AxisAlignedBox3 &box, 
+													ViewCellContainer &viewCells) const
+{
+	return mVspBspTree->ComputeBoxIntersections(box, viewCells);
+}
+
+
+int VspBspViewCellsManager::CastLineSegment(const Vector3 &origin,
+											const Vector3 &termination,
+											ViewCellContainer &viewcells)
+{
+	return mVspBspTree->CastLineSegment(origin, termination, viewcells);
 }
 
